import {
  queryCampusList,
  queryTerminalsList,
  queryCampusAmount,
  queryTerminalsAmount,
  queryTotalList,
  queryDidLabelList,
} from '../services/accounts';

export default {
  namespace: 'accounts',
  state: {
    list: [],
    pageNo: 1,
    pageSize: 15,
    totalSize: 0,
    campusAmount: 0,
    currentItem: {},
  },
  effects: {
    *fetchCampusList({ payload }, { call, put }) {
      const response = yield call(queryCampusList, payload);
      if (response.success) {
        yield put({
          type: 'querySuccess',
          payload: {
            list: response.data.list || [],
            pageSize: response.data.pageSize,
            totalSize: response.data.totalSize,
            pageNo: response.data.pageNo,
          },
        });
      }
    },
    *fetchTerminalsList({ payload }, { call, put }) {
      const response = yield call(queryTerminalsList, payload);
      if (response.success) {
        yield put({
          type: 'querySuccess',
          payload: {
            list: response.data.list || [],
            pageSize: response.data.pageSize,
            totalSize: response.data.totalSize,
            pageNo: response.data.pageNo,
          },
        });
      }
    },
    *fetchCampusAmount({ payload }, { call, put }) {
      const response = yield call(queryCampusAmount, payload);
      if (response.success) {
        yield put({
          type: 'querySuccess',
          payload: {
            campusAmount: response.data,
          },
        });
      }
    },
    *fetchTerminalsAmount({ payload }, { call, put }) {
      const response = yield call(queryTerminalsAmount, payload);
      if (response.success) {
        yield put({
          type: 'querySuccess',
          payload: {
            terminalsAmount: response.data,
          },
        });
      }
    },
    *fetchTotalList({ payload }, { call, put }) {
      const response = yield call(queryTotalList, payload);
      if (response.success) {
        yield put({
          type: 'querySuccess',
          payload: {
            list: response.data.list || [],
            pageSize: response.data.pageSize,
            totalSize: response.data.totalSize,
            pageNo: response.data.pageNo,
          },
        });
      }
    },
    *fetchDidLabelList({ payload }, { call, put }) {
      const response = yield call(queryDidLabelList, payload);
      if (response.success) {
        yield put({
          type: 'querySuccess',
          payload: {
            list: response.data.list || [],
            pageSize: response.data.pageSize,
            totalSize: response.data.totalSize,
            pageNo: response.data.pageNo,
          },
        });
      }
    },
    *fetchCampusExcel() {
      const url = '/api/stmt/campus/export';
      window.location.href = url;
    },
    *fetchTerminalsExcel() {
      const url = '/api/stmt/terminal/user/export';
      window.location.href = url;
    },
    *fetchDidLabelExcel() {
      const url = '/api/stmt/userTagStmt/export';
      window.location.href = url;
    },
    *fetchOverdueExcel() {
      const url = '/api/stmt/terminal/user/export?fastExpired=1';
      window.location.href = url;
    },
  },

  reducers: {
    querySuccess(state, action) {
      return {
        ...state,
        ...action.payload,
      };
    },
  },

};
